/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.web.search;

import fr.gouv.finances.dgfip.utils.Pair;
import fr.gouv.finances.dgfip.xemelios.common.config.ChampModel;
import fr.gouv.finances.dgfip.xemelios.data.DataImpl;
import fr.gouv.finances.dgfip.xemelios.data.DataLayerManager;
import fr.gouv.finances.dgfip.xemelios.services.XemeliosHelper;
import fr.gouv.finances.dgfip.xemelios.web.utils.StdDispatchAction;
import java.util.Hashtable;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author CBO
 */
public class searchAction extends StdDispatchAction {

    @Override
    public ActionForward unspecified(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        return init(mapping, form, request, response);
    }

    public ActionForward init(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        String documentId = request.getParameter("documentId");
        String etatId = request.getParameter("etatId");
        String elementId = request.getParameter("elementId");
        request.setAttribute("documentId", documentId);
        request.setAttribute("etatId", etatId);
        request.setAttribute("elementId", elementId);
        request.setAttribute("documentTitle", XemeliosHelper.getDocumentsModel(documentId).getEtatById(etatId).getElementById(elementId).getTitre());

        DataImpl impl = DataLayerManager.getImplementation();
        Hashtable<String,Pair[]> operators = new Hashtable<String,Pair[]>();
        operators.put(ChampModel.DATATYPE_AMOUNT, impl.getAggregateOperators(ChampModel.DATATYPE_AMOUNT));
        operators.put(ChampModel.DATATYPE_DATE, impl.getAggregateOperators(ChampModel.DATATYPE_DATE));
        operators.put(ChampModel.DATATYPE_DECIMAL, impl.getAggregateOperators(ChampModel.DATATYPE_DECIMAL));
        operators.put(ChampModel.DATATYPE_INTEGER, impl.getAggregateOperators(ChampModel.DATATYPE_INTEGER));
        request.setAttribute("operators", operators);
        return mapping.getInputForward();
    }
}
